osgGA::Device Class Reference

`#include <Device>`

Inheritance diagram for osgGA::Device:

## Public Types

enum | Capabilities { UNKNOWN = 0 , RECEIVE_EVENTS = 1 , SEND_EVENTS = 2 }
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Device ()
| Device (const Device &es, const osg::CopyOp &copyop)
| META_Object (osgGA, Device)
int | getCapabilities () const
virtual bool | checkEvents ()
virtual void | sendEvent (const Event &ea)
virtual void | sendEvents (const EventQueue::Events &events)
void | setEventQueue (osgGA::EventQueue *eventQueue)
osgGA::EventQueue * | getEventQueue ()
const osgGA::EventQueue * | getEventQueue () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

void | setCapabilities (int capabilities)
virtual | ~Device ()
Device & | operator= (const Device &)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::ref_ptr< osgGA::EventQueue > | _eventQueue
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Device base class from abstracting away from devices/windows that can generate events.

## Member Enumeration Documentation

## Capabilities

enum osgGA::Device::Capabilities

Enumerator
UNKNOWN |
RECEIVE_EVENTS |
SEND_EVENTS |

## Constructor & Destructor Documentation

## Device() [1/2]

osgGA::Device::Device | ( |  | ) |

Referenced by Device(), META_Object(), and operator=().

## Device() [2/2]

osgGA::Device::Device | ( | const Device & | es,
|  | const osg::CopyOp & | copyop )

References Device().

## ~Device()

virtual osgGA::Device::~Device | ( |  | ) |

protected virtual

## Member Function Documentation

## checkEvents()

virtual bool osgGA::Device::checkEvents | ( |  | ) |

inline virtual

References _eventQueue, and getEventQueue().

## getCapabilities()

int osgGA::Device::getCapabilities | ( |  | ) | const

inline

## getEventQueue() [1/2]

osgGA::EventQueue * osgGA::Device::getEventQueue | ( |  | ) |

inline

References _eventQueue.

Referenced by checkEvents().

## getEventQueue() [2/2]

const osgGA::EventQueue * osgGA::Device::getEventQueue | ( |  | ) | const

inline

References _eventQueue.

## META_Object()

osgGA::Device::META_Object | ( | osgGA | ,
|  | Device | )

References Device().

## operator=()

Device & osgGA::Device::operator= | ( | const Device & |  | ) |

inline protected

Prevent unwanted copy operator.

References Device().

## sendEvent()

virtual void osgGA::Device::sendEvent | ( | const Event & | ea | ) |

virtual

## sendEvents()

virtual void osgGA::Device::sendEvents | ( | const EventQueue::Events & | events | ) |

virtual

## setCapabilities()

void osgGA::Device::setCapabilities | ( | int | capabilities | ) |

inline protected

## setEventQueue()

void osgGA::Device::setEventQueue | ( | osgGA::EventQueue * | eventQueue | ) |

inline

References _eventQueue.

## Member Data Documentation

## _eventQueue

osg::ref_ptr<osgGA::EventQueue> osgGA::Device::_eventQueue

protected

Referenced by checkEvents(), getEventQueue(), getEventQueue(), and setEventQueue().

The documentation for this class was generated from the following file:

- Device